-- I don't know to use .pkgmeta yet with Subversion,
-- and dont want to hardembed Ace3
local AA = LibStub("AceAddon-3.0", true)
local ACR = LibStub("AceConfigRegistry-3.0", true)
local ACD = LibStub("AceConfigDialog-3.0", true)

-- just unregister it and do nothing else, if we cant use the Ace3 options tables
if not AA or not ACR or not ACD then TimerTracker:UnregisterAllEvents() return end

RemoveCountdown = AA:NewAddon("RemoveCountdown", "AceEvent-3.0")
local RC = RemoveCountdown

local function UpdateRegisters()
	if RemoveCountdownDB then
		-- only disable the StatusBar when it pops up
		TimerTracker:RegisterEvent("START_TIMER")
		TimerTracker:RegisterEvent("PLAYER_ENTERING_WORLD")
	else
		-- disable the whole thing altogether
		TimerTracker:UnregisterAllEvents()
	end
end

function RC:OnInitialize()
	self:RegisterEvent("START_TIMER")
	UpdateRegisters()
end

function RC:START_TIMER()
	if RemoveCountdownDB then
		for i = 1, #TimerTracker.timerList do
			_G["TimerTrackerTimer"..i.."StatusBar"]:Hide()
		end
	end
end

local options = {
	type = "group",
	name = "",
	args = {
		TimerBar = {
			type = "toggle",
			descStyle = "",
			width = "full",
			name = "BigTimerNumbers",
			get = function(i) return RemoveCountdownDB end,
			set = function(i, v) RemoveCountdownDB = v; UpdateRegisters() end,
		},
		BigTimerNumbers = {
			type = "description",
			descStyle = "",
			name = "|TInterface\\Timer\\BigTimerNumbers:170:256|t",
		},
	}
}

ACR:RegisterOptionsTable("RemoveCountdown", options)
local optionsFrame = ACD:AddToBlizOptions("RemoveCountdown", "RemoveCountdown")

local function SlashCommand()
	InterfaceOptionsFrame_OpenToCategory(optionsFrame)
end

local AC = LibStub("AceConsole-3.0", true)
if AC then
	AC:RegisterChatCommand("rc", SlashCommand)
	AC:RegisterChatCommand("removecountdown", SlashCommand)
end